import hell2;
import token;
import scenetitle;
import scenemain;
import sceneend;

// 画面サイズ
const int g_width  = 640;
const int g_height = 480;

/**
 * リソース読込
 */
void load()
{
	Hell_loadTexture("all", "resource/image/all.bmp", [0x00, 0xff, 0x00]);
	Hell_loadTexture("view", "resource/image/view.bmp", [0x00, 0xff, 0x00]);
	Hell_loadWAV("shot",     "resource/sound/shot.wav");
	Hell_loadWAV("bomb",     "resource/sound/bomb.wav");
	Hell_loadWAV("pipi",     "resource/sound/pipi.wav");
	Hell_loadWAV("danger",     "resource/sound/danger.wav");
	Hell_loadWAV("timeup",     "resource/sound/timeup.wav");
}

int Hell_main(char[][] args)
{
	try
	{
		Hell_init("Sniper2008", g_width, g_height);
		IToken.setScreen(g_width, g_height);

		load();
		
		SceneManager.regist("title", new SceneTitle());
		SceneManager.regist("main",  new SceneMain());
		SceneManager.regist("end",   new SceneEnd());
		SceneManager.change("title");
		SceneManager.get().init();
		
		while(true)
		{
			Hell_begin();
			SceneManager.update();
			Hell_update();
			Hell_wait(16); // 60fps
		}
	}
	catch(Exception e)
	{
		Hell_write(e);
	}
	finally
	{
		Hell_quit();
	}
	
	return 0;
}


// エントリポイント
public int main(char[][] args)
{
	return Hell_main(args);
}

